#include "queue_internal.h"





/****************************************************************************/
void queue_query( void *queue_state, enum queue_query_type query_type, void *query_result )
{
  struct queue_state
    *qs;

  assert( queue_state != NULL );
  // TRD : query_type can be any value in its range
  assert( query_result != NULL );

  qs = (struct queue_state *) queue_state;

  switch( query_type )
  {
    case QUEUE_QUERY_ELEMENT_COUNT:
      freelist_query( qs->freelist_state, FREELIST_QUERY_ELEMENT_COUNT, query_result );
    break;
  }

  return;
}

