#include "ringbuffer_internal.h"





/****************************************************************************/
void ringbuffer_put_read_element( void *ringbuffer_state, void *ringbuffer_element )
{
  struct ringbuffer_state
    *rs;

  struct ringbuffer_element
    *re;

  assert( ringbuffer_state != NULL );
  assert( ringbuffer_element != NULL );

  rs = (struct ringbuffer_state *) ringbuffer_state;
  re = (struct ringbuffer_element *) ringbuffer_element;

  freelist_push( rs->freelist_state, re->freelist_element );

  return;
}





/****************************************************************************/
void ringbuffer_put_write_element( void *ringbuffer_state, void *ringbuffer_element )
{
  struct ringbuffer_state
    *rs;

  assert( ringbuffer_state != NULL );
  assert( ringbuffer_element != NULL );

  rs = (struct ringbuffer_state *) ringbuffer_state;

  ringbuffer_internal_enqueue_element( ringbuffer_state, ringbuffer_element );

  return;
}

