#include "freelist_internal.h"





/****************************************************************************/
void *freelist_get_user_data_from_element( void *freelist_element, void **user_data )
{
  struct freelist_element
    *fe;

  assert( freelist_element != NULL );
  // TRD : user_data can be NULL

  fe = (struct freelist_element *) freelist_element;

  if( user_data != NULL )
    *user_data = fe->user_data;

  return( fe->user_data );
}





/****************************************************************************/
void freelist_set_user_data_in_element( void *freelist_element, void *user_data )
{
  struct freelist_element
    *fe;

  assert( freelist_element != NULL );
  assert( user_data != NULL );

  fe = (struct freelist_element *) freelist_element;

  fe->user_data = user_data;

  return;
}

